<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<meta http-equiv="Cache-Control" content="no-cache, no-store, must-revalidate">
	<meta http-equiv="Pragma" content="no-cache">
	<meta http-equiv="Expires" content="0">
	<title>Weilianqi</title>
	<link rel="stylesheet" href="../style.css">
</head>

<body>
<header>
<nav>
	<ul>
		<li><a href="/">Home</a></li>
		<li><a href="/play.html">Play</a></li>
		<li><a href="/articles.html">Articles</a></li>
	</ul>
</nav>
</header>
<main>
<h1>A frontend for the rps chain</h1>

<p><small>Published 7th March 2022.</small></p>

<p>This is a continuation of the <a href="rps-migration.html">previous rps article</a>, to follow along either go through the previous articles or acquire <a href="https://gitlab.com/marcus.appelros/rps/-/tree/v0.2" target="_blank">v0.2 of the repository</a>. Here we add a frontend that connects to Keplr with cosmjs.</p>

<p>Start with commenting out the upgrade registration in the end block hook in app/app.go.</p>

<p>Make a new directory in the rps folder and create a index.html containing a button that calls the following function:</p>

<pre class="prebox"><code>async function connectKeplr(){
	await window.keplr.experimentalSuggestChain({
		chainId: "rps",
		chainName: "Rock paper scissors",
		rpc: "http://0.0.0.0:26657",
		rest: "http://0.0.0.0:1317",
		bip44: {
			coinType: 118,
		},
		bech32Config: {
			bech32PrefixAccAddr: "rps",
			bech32PrefixAccPub: "rps" + "pub",
			bech32PrefixValAddr: "rps" + "valoper",
			bech32PrefixValPub: "rps" + "valoperpub",
			bech32PrefixConsAddr: "rps" + "valcons",
			bech32PrefixConsPub: "rps" + "valconspub",
		},
		currencies: [ 
			{ 
				coinDenom: "MSTAKE", 
				coinMinimalDenom: "stake", 
				coinDecimals: 6, 
			}, 
			{
				coinDenom: "win",
				coinMinimalDenom: "win",
				coinDecimals: 0,
			},
			{
				coinDenom: "draw",
				coinMinimalDenom: "draw",
				coinDecimals: 0,
			},
		],
		feeCurrencies: [
			{
				coinDenom: "MSTAKE",
				coinMinimalDenom: "stake",
				coinDecimals: 6,
			},
		],
		stakeCurrency: {
			coinDenom: "MSTAKE",
			coinMinimalDenom: "stake",
			coinDecimals: 6,
		},
		coinType: 118,
		gasPriceStep: {
			low: 0,
			average: 0.001,
			high: 0.003,
		},
	});
	window.keplr.enable("rps");
}
</code></pre>

<p>Unfortunately Keplr is not injected when we view this as a file, so we have to serve it, for example through node with <code>npx http-server</code></p>

<p>After pressing the button you will be able to send tokens through the Keplr extension.</p>

<p>Next run <code>npm init</code> and <code>npm install ts-proto --save-dev</code> which is needed for protoc, create tx.ts with the following command:</p>

<pre class="prebox"><code>protoc \
	--plugin="./node_modules/.bin/protoc-gen-ts_proto" \
	--ts_proto_out="./" \
	--proto_path="../proto/rps" \
	--ts_proto_opt="esModuleInterop=true,forceLong=long,useOptionals=messages" \
	"../proto/rps/tx.proto"
</code></pre>

<p>Install the tsc typescript compiler with <code>npm install -g typescript</code> and run it: <code>tsc tx.ts</code></p>

<p>It gives an error that protobufjs/minimal has no default export, so remove all instances of ["default"] in tx.js with a search and replace. The other errors regarding missing fields can apparently be ignored.</p>

<p>Next install the stargete cosmjs package with <code>npm install @cosmjs/stargate</code></p>

<p>We have to register the correct path for our transactions, it can be found in the init function of x/rps/types/tx.pb.go: <code>proto.RegisterType((*MsgJoinQueue)(nil), "marcus.appelros.rps.rps.MsgJoinQueue")</code></p>

<p>Create a index.js file and fill it with the following:</p>

<pre class="prebox"><code>import { Registry } from "@cosmjs/proto-signing";
import {
	defaultRegistryTypes as defaultStargateTypes,
	SigningStargateClient,
} from "@cosmjs/stargate";
import { MsgJoinQueue } from "./tx.js";

var rps = {};
window.rps = rps;

const customRegistry = new Registry(defaultStargateTypes);
customRegistry.register("/marcus.appelros.rps.rps.MsgJoinQueue", MsgJoinQueue);

async function getClient() {
	await window.keplr.enable("rps");
	const offlineSigner = window.keplr.getOfflineSigner("rps");
	const client = await SigningStargateClient.connectWithSigner(
		"http://0.0.0.0:26657",
		offlineSigner,
		{ registry: customRegistry },
	);
	return client;
}
rps.getClient = getClient;

async function joinQueue() {
	const client = await getClient();
	const accounts = await client.signer.getAccounts();
	const message = {
		typeUrl: "/marcus.appelros.rps.rps.MsgJoinQueue",
		value: MsgJoinQueue.fromPartial({
			creator: accounts[0].address,
		}),
	};
	const fee = {
		amount: [
			{
				denom: "stake",
				amount: "100",
			},
		],
		gas: "100000",
	};
	const response = await client.signAndBroadcast(accounts[0].address, [message], fee);
	return response;
}
rps.joinQueue = joinQueue;
</code></pre>

<p>Next we assemble the code for importing in index.html with webpack, using webpack-5 is <a href="https://github.com/cosmos/cosmjs/issues/1061" target="_blank">a little finicky</a> so I will use version 4: <code>npm install -g webpack@4.46.0 webpack-cli</code></p>

<p>Create webpack.config.js:</p>

<pre class="prebox"><code>module.exports = {
  entry: './index.js',
  output: {
    path: __dirname + '/dist',
    filename: 'bundle.js',
  },
};
</code></pre>

<p>Then run webpack and import dist/bundle.js in index.html, refresh the served file with ctrl-shift-r and try rps.joinQueue() in the console.</p>

<p>Since in production one would likely use Vue or another framework we simply use the console here.</p>

<p>Our code gets a new client before sending a transaction, if you want a persistent client and/or display data it is helpful to have it update automatically when a user changes their Keplr account: <code>window.addEventListener("keplr_keystorechange", updateInfo)</code></p>

<p>After starting a match we want to be able to check this games id through the player map so we can submit moves correctly, in proto/rps/query.proto you can see the built in paths to accomplish this: </code>option (google.api.http).get = "/marcus.appelros/rps/rps/player/{index}";</code></p>

<p>So we can simply visit http://0.0.0.0:1317/marcus.appelros/rps/rps/player/rps1xyz or http://0.0.0.0:1317/marcus.appelros/rps/rps/player to view all players. If you want this functionality through cosmjs check out <a href="https://github.com/cosmos/cosmjs/blob/main/packages/stargate/CUSTOM_PROTOBUF_CODECS.md#step-3b-instantiate-a-query-client-using-your-custom-query-service" target="_blank">this guide.</a></p>

<p>Now it is time to add functionality for submitting moves. In index.js import MsgSubmitMove from tx.js and register it with the correct path, then add the following:</p>

<pre class="prebox"><code>async function submitMove(matchId, moveId) {
	const client = await getClient();
	const accounts = await client.signer.getAccounts();
	const message = {
		typeUrl: "/marcus.appelros.rps.rps.MsgSubmitMove",
		value: MsgSubmitMove.fromPartial({
			creator: accounts[0].address,
			matchId: matchId,
			moveId: moveId,
		}),
	};
	const fee = {
		amount: [
			{
				denom: "stake",
				amount: "100",
			},
		],
		gas: "100000",
	};
	const response = await client.signAndBroadcast(accounts[0].address, [message], fee);
	return response;
}
rps.submitMove = submitMove;
</code></pre>

<p>Recompile with webpack, refresh and try rps.submitMove(0,1) with appropriate numbers.</p>

<p>That's it! For the complete code check out <a href="https://gitlab.com/marcus.appelros/rps/-/tree/master/frontend" target="_blank">the frontend folder in the repository.</a></p>

<br><br><br><br><br><br><br>
</main>
<footer>
<nav>
	<ul>
		<li><a href="/">Home</a></li>
		<li><a href="/play.html">Play</a></li>
		<li><a href="/articles.html">Articles</a></li>
	</ul>
</nav>
</footer>
</body>

</html>
